--Trigger responsvel por bloquear a retirada caso o lote esteja vencido

CREATE OR REPLACE TRIGGER VD_LOTE_VENCIDO BEFORE INSERT ON ITLANCTOEST
FOR EACH ROW
DECLARE
   V_DTVALILOTE   DATE;
   V_RETIRADA     NUMBER;
   V_NMPRODUTO    VARCHAR2(50);
   V_IDUTCTRLLOTE VARCHAR2(01);
BEGIN   

   BEGIN
      SELECT IDUTCTRLLOTE
        INTO V_IDUTCTRLLOTE
        FROM PRODFILI
       WHERE (CDFILIAL  = :NEW.CDFILIAL )
         AND (CDPRODUTO = :NEW.CDPRODUTO);
   EXCEPTION
      WHEN NO_DATA_FOUND THEN BEGIN
         V_IDUTCTRLLOTE := 'N';
      END;
   END;

   --RETIRADA   
   IF ((:NEW.IDTIPOMOVI = '3') AND (V_IDUTCTRLLOTE = 'S')) THEN
      BEGIN
         SELECT COUNT(*)
           INTO V_RETIRADA
           FROM LOTITRETIEST L, ITEMRETIEST I
          WHERE (L.NRLANCESTQ IS NULL            )
            AND (L.CDFILIAL     = :NEW.CDFILIAL  )
            AND (L.CDPRODUTO    = :NEW.CDPRODUTO )
            AND (L.NRLOTEESTQ   = :NEW.NRLOTEESTQ)
            AND (L.NRSUBLOTE    = :NEW.NRSUBLOTE )
            AND (I.CDTIPORETI   = :NEW.CDTIPORETI)
            AND (L.CDFILIAL     = I.CDFILIAL     )
            AND (L.NRRETEST     = I.NRRETEST     )
            AND (L.NRSEQRETPROD = I.NRSEQRETPROD );
      EXCEPTION
         WHEN NO_DATA_FOUND THEN BEGIN
            V_RETIRADA := 0;
         END;
      END;
      IF (V_RETIRADA > 0) THEN
         BEGIN
            SELECT DTVALILOTE, NMPRODUTO
              INTO V_DTVALILOTE, V_NMPRODUTO
              FROM LOTE L, PRODUTO P
             WHERE (L.CDPRODUTO  = P.CDPRODUTO    )
               AND (L.CDFILIAL   = :NEW.CDFILIAL  )
               AND (L.CDPRODUTO  = :NEW.CDPRODUTO )
               AND (L.NRLOTEESTQ = :NEW.NRLOTEESTQ)
               AND (L.NRSUBLOTE  = :NEW.NRSUBLOTE );
         EXCEPTION
            WHEN NO_DATA_FOUND THEN BEGIN
               V_DTVALILOTE := NULL;
               V_NMPRODUTO  := NULL;
            END;
         END;
         IF (TRUNC(V_DTVALILOTE) < TRUNC(SYSDATE)) THEN
            RAISE_APPLICATION_ERROR(-20501, '_ Produto '||V_NMPRODUTO||' com Lote Vencido: '||:NEW.NRLOTEESTQ||' - '||V_DTVALILOTE||' _');
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('VD_LOTE_VENCIDO','6.05.xxx'); END;
/